searchNodes=[{"doc":"Module to get files out of a zip. Works with local and remote files Overview Unzip tries to solve problem of accessing files from a zip which is not local (Aws S3, sftp etc). It does this by simply separating file system and zip implementation. Anything which implements Unzip.FileAccess can be used to get zip contents. Unzip relies on the ability to seek and read of the file, This is due to the nature of zip file. Files from the zip are read on demand. Usage # Unzip.LocalFile implements Unzip.FileAccess zip_file = Unzip.LocalFile . open ( &quot;foo/bar.zip&quot; ) # `new` reads list of files by reading central directory found at the end of the zip { :ok , unzip } = Unzip . new ( zip_file ) # presents already read files metadata file_entries = Unzip . list_entries ( unzip ) # returns decompressed file stream stream = Unzip . file_stream! ( unzip , &quot;baz.png&quot; ) Supports STORED and DEFLATE compression methods. Does not support zip64 specification yet","ref":"Unzip.html","title":"Unzip","type":"module"},{"doc":"Returns decompressed file entry from the zip as a stream. file_name must be complete file path. File is read in the chunks of 65k","ref":"Unzip.html#file_stream!/2","title":"Unzip.file_stream!/2","type":"function"},{"doc":"Returns list of files metadata. This does not make pread call as metadata is already by new/1 . See Unzip.Entry for metadata fields","ref":"Unzip.html#list_entries/1","title":"Unzip.list_entries/1","type":"function"},{"doc":"Creates Unzip struct by reading central directory found at the end of the zip (reads entries in the file)","ref":"Unzip.html#new/1","title":"Unzip.new/1","type":"function"},{"doc":"File metadata returned by Unzip.list_entries/1 :file_name - (string) File name with complete path. Directory files will have / at the end of their name :last_modified_datetime - (NaiveDateTime) last modified date and time of the file :compressed_size - (positive integer) Compressed file size in bytes :uncompressed_size - (positive integer) Uncompressed file size in bytes","ref":"Unzip.Entry.html","title":"Unzip.Entry","type":"module"},{"doc":"Should be implemented for the module which can read from the file system.","ref":"Unzip.FileAccess.html","title":"Unzip.FileAccess","type":"protocol"},{"doc":"Reads the chunk of data from the file . It should return {:ok, binary} where binary is the chunk found at offset with length length","ref":"Unzip.FileAccess.html#pread/3","title":"Unzip.FileAccess.pread/3","type":"function"},{"doc":"Returns the size of the file in bytes.","ref":"Unzip.FileAccess.html#size/1","title":"Unzip.FileAccess.size/1","type":"function"},{"doc":"","ref":"Unzip.FileAccess.html#t:chunk/0","title":"Unzip.FileAccess.chunk/0","type":"type"},{"doc":"","ref":"Unzip.FileAccess.html#t:reason/0","title":"Unzip.FileAccess.reason/0","type":"type"},{"doc":"","ref":"Unzip.FileAccess.html#t:t/0","title":"Unzip.FileAccess.t/0","type":"type"},{"doc":"Simple module to access local zip file and example for implementing Unzip.FileAccess . Note: this is basic implementation, it is callers responsibility to handle resource properly","ref":"Unzip.LocalFile.html","title":"Unzip.LocalFile","type":"module"},{"doc":"","ref":"Unzip.LocalFile.html#close/1","title":"Unzip.LocalFile.close/1","type":"function"},{"doc":"","ref":"Unzip.LocalFile.html#open/1","title":"Unzip.LocalFile.open/1","type":"function"},{"doc":"","ref":"Unzip.Error.html","title":"Unzip.Error","type":"exception"},{"doc":"Elixir library to stream zip file contents. Works with remote files. Supports Zip64.","ref":"readme.html","title":"Unzip","type":"extras"},{"doc":"Unzip tries to solve problem of accessing files from a zip which stored in a remote storage medium (Aws S3, SFTP server etc). It separates storage medium from zip implementation. Unzip can stream zip contents from any storage which implements Unzip.FileAccess protocol. You can selectively stream files from zip without reading complete zip, because of this we can saves bandwidth and time when you only need few files from a large zip. For example, if a zip file contains 100 files and we only want one specific file then Unzip read only that file.","ref":"readme.html#overview","title":"Unzip - Overview","type":"extras"},{"doc":"def deps do [ { :unzip , &quot;~&gt; x.x.x&quot; } ] end","ref":"readme.html#installation","title":"Unzip - Installation","type":"extras"},{"doc":"# Unzip.LocalFile implements Unzip.FileAccess zip_file = Unzip.LocalFile . open ( &quot;foo/bar.zip&quot; ) # `new` reads list of files by reading central directory found at the end of the zip { :ok , unzip } = Unzip . new ( zip_file ) # presents already read files metadata file_entries = Unzip . list_entries ( unzip ) # returns decompressed file stream stream = Unzip . file_stream! ( unzip , &quot;baz.png&quot; ) Supports STORED and DEFLATE compression methods. Supports zip64 specification.","ref":"readme.html#usage","title":"Unzip - Usage","type":"extras"},{"doc":"For Aws S3 using ExAws defmodule Unzip.S3File do defstruct [ :path , :bucket , :s3_config ] alias __MODULE__ def new ( path , bucket , s3_config ) do % S3File { path : path , bucket : bucket , s3_config : s3_config } end end defimpl Unzip.FileAccess , for : Unzip.S3File do alias ExAws.S3 def size ( file ) do %{ headers : headers } = S3 . head_object ( file . bucket , file . path ) |&gt; ExAws . request! ( file . s3_config ) size = headers |&gt; Enum . find ( fn { k , _ } -&gt; String . downcase ( k ) == &quot;content-length&quot; end ) |&gt; elem ( 1 ) |&gt; String . to_integer ( ) { :ok , size } end def pread ( file , offset , length ) do { _ , chunk } = S3.Download . get_chunk ( % S3.Download { bucket : file . bucket , path : file . path , dest : nil } , %{ start_byte : offset , end_byte : offset + length - 1 } , file . s3_config ) { :ok , chunk } end end # Using S3File aws_s3_config = ExAws.Config . new ( :s3 , access_key_id : [ &quot;key_id&quot; , :instance_role ] , secret_access_key : [ &quot;key&quot; , :instance_role ] ) file = Unzip.S3File . new ( &quot;pets.zip&quot; , &quot;pics&quot; , aws_s3_config ) { :ok , unzip } = Unzip . new ( file ) files = Unzip . list_entries ( unzip ) Unzip . file_stream! ( unzip , &quot;cats/kitty.png&quot; ) |&gt; Stream . into ( File . stream! ( &quot;kitty.png&quot; ) ) |&gt; Stream . run ( ) For zip file in SFTP server defmodule Unzip.SftpFile do defstruct [ :channel_pid , :connection_ref , :handle , :file_path ] alias __MODULE__ def new ( host , port , sftp_opts , file_path ) do :ok = :ssh . start ( ) { :ok , channel_pid , connection_ref } = :ssh_sftp . start_channel ( to_charlist ( host ) , port , sftp_opts ) { :ok , handle } = :ssh_sftp . open ( channel_pid , file_path , [ :read , :raw , :binary ] ) % SftpFile { channel_pid : channel_pid , connection_ref : connection_ref , handle : handle , file_path : file_path } end def close ( file ) do :ssh_sftp . close ( file . channel_pid , file . handle ) :ssh_sftp . stop_channel ( file . channel_pid ) :ssh . close ( file . connection_ref ) :ok end end defimpl Unzip.FileAccess , for : Unzip.SftpFile do def size ( file ) do { :ok , file_info } = :ssh_sftp . read_file_info ( file . channel_pid , file . file_path ) { :ok , elem ( file_info , 1 ) } end def pread ( file , offset , length ) do :ssh_sftp . pread ( file . channel_pid , file . handle , offset , length ) end end # Using SftpFile sftp_opts = [ user_interaction : false , silently_accept_hosts : true , rekey_limit : 1_000_000_000_000 , user : &#39;user&#39; , password : &#39;password&#39; ] file = Unzip.SftpFile . new ( &#39;127.0.0.1&#39; , 22 , sftp_opts , &#39;/home/user/pics.zip&#39; ) try do { :ok , unzip } = Unzip . new ( file ) files = Unzip . list_entries ( unzip ) Unzip . file_stream! ( unzip , &quot;cats/kitty.png&quot; ) |&gt; Stream . into ( File . stream! ( &quot;kitty.png&quot; ) ) |&gt; Stream . run ( ) after Unzip.SftpFile . close ( file ) end","ref":"readme.html#examples-of-implementing-unzip-fileaccess-protocol","title":"Unzip - Examples of implementing Unzip.FileAccess protocol","type":"extras"}]